/// <reference types="node" />
import SocketIO from "socket.io";
import type { Server as ServerBase, ServerProps } from "@react-fullstack/fullstack/server";
import type { Server as HTTPServer } from "http";
interface Props extends Pick<ServerProps<any, any>, 'children' | 'singleInstance' | 'instanceRenderHandler'> {
    /**
     * The port the socket will run on.
     */
    port?: number;
    /**
     * pass existing http server to socket.io
     */
    server?: HTTPServer;
    /**
     * socket.io server options, note: must be passed with the first component mount, updating this prop will have no effect.
     * Note: cors header does not default to "*"
     */
    socketOptions?: Partial<SocketIO.ServerOptions>;
}
declare function createSocketServer(Server: typeof ServerBase): (props: Props) => JSX.Element;
export { createSocketServer };
